/* qksort - sort array a (dimension n) using quicksort
 */
#include "local.h"
void qksort(a, n)
	int a[];
	int n;
	{
	iqksort(a, 0, n-1);
	isort(a, n);
	}
static void iqksort(a, lo, hi)
	int a[];
	int lo, hi;
	{
	int mid = (lo + hi) / 2;
	int i;
	int lastlo;
	int t;
	int tmp;

	if (hi - lo < 16)		/* should not use (hi < lo + 16) */
		return;
	SWAP(a[lo], a[mid], tmp);
	t = a[lo];
	lastlo = lo;
	for (i = lo+1; i <= hi; ++i)
		{
		if (a[i] < t)
			{
			++lastlo;
			SWAP(a[lastlo], a[i], tmp);
			}
		}
	SWAP(a[lo], a[lastlo], tmp);
	iqksort(a, lo, lastlo - 1);
	iqksort(a, lastlo + 1, hi);
	}
/* isort - sort array a (dimension n) using insertion sort
 */
void isort(a, n)
	int a[];
	int n;
	{
	int i;
	int j;
	int t;

	for (i = 1; i < n; ++i)	/* a[0:i-1]=>sorted */
		{
		t = a[i];
		j = i;
		while (j > 0 && a[j-1] > t)
			{
			a[j] = a[j-1];
			--j;
			}
		a[j] = t;
		}
	/* a=>sorted */
	}
#ifdef TRYMAIN
#include <math.h>
main(ac, av)
	int ac;
	char *av[];
	{
	int i;
	int lim;
	static int a[10000];
	double nlogn;
	double tim;
	long cputim();

	lim = atoi(av[1]);
	printf("lim=%d\n", lim);
	for (i = 0; i < lim; ++i)
		a[i] = rand();
	cputim();
	qksort(a, lim);
	tim = cputim() * 1e6 / 60;
	printf("cpu time = %.3f (sec)\n", tim / 1e6);
	nlogn = lim * log((double)lim) / log(2.);
	printf("log N = %.3f\n", log((double)lim) / log(2.));
	printf("N log N = %.3f\n", nlogn);
	printf("cpu time = %.2f N log N (usec)\n", tim / nlogn);
	for (i = 0; i < lim-1; ++i)
		{
		if (a[i] > a[i+1])
			error("bad value", "");
		}
	exit(SUCCEED);
	}
#endif
